# KM V6.1.0.0 部署手册

## 1.轻文档配置

### 1.修改 envfile.env

如下参数配置为部署服务器外网访问 ip
```yaml
Config.Docflow.DefaultHost=172.16.2.95
```

### 2. 修改 sharestorage environment SqlConnection 参数

如果数据库是mysql，使用默认的环境变量参数即可，如果是其他数据库，配置为对应的数据库连接字符串

```yaml
sharestorage:
        hostname: sharestorage
        image: 192.168.251.78/edoc2v5/sharestorage:202209021545
        environment:
            - SqlConnection=server=mysql;port=3306;user=user;password=1qaz2WSX; database=edoc2v5;
            - DataProvider=mysql
```

## 2.部署

### 1. 环境变量检查

如下的环境变量，不以 `# ` 开头的，都是需要加的环境变量

```
STORAGEPLATFORM=0
HTTP_PROTOCOL_TYPE=http
S3_Url=S3URL
S3_SecretKey=S3SECRET
S3_AccessKey=S3ACCESS
S3_Bucket=S3BUCKET
S3_SignatureVersion=4
Ceph_HealthUrl=S3HealthUrl
OSS_ISCNAME=false
ESURL=http://es:9200
CACHEMODULE=redis
ISUDC=0
PRODUCTION=edoc2
INBIZ=true
#InBizHttpServicePort=80
#InBizGrpcServicePort=5003
INBIZURL=http://inbiz
INBIZGRPCURL=http://inbiz:5003
#InBizV6HttpServicePort=5006
#InBizV6GrpcServicePort=15006
INBIZV6URL=http://inbiz-backend:5006
INBIZV6GRPCURL=http://inbiz-backend:15006
ECMURL=http://edoc2
ECMGRPCURL=http://edoc2:5002
#INSIGHTURL=http://searchengine
#Region_TSAP={Region_TSAP}
#ENCRYPTENGINE=VtExt
#DatabaseType=1
#DatabaseServerName=sqlserver
#DatabaseServerPort=1433
#DatabaseUserName=sa
#DatabasePassword=1qaz2WSX
#IsSendNotNeedIndexToMQ=true
#InWiseIndexQueueName=index_inwise_queue|true
#OCR_MAXFILESIZE=10,80
#NUMS=25
#ThreadCheck=true
IsUpgrade=6.5.3.0
#ENCRYPTENGINE=SmartSec
#SharedStorageId=0
#DecryptDebug=1
#DECRYPTGRPCURL=http://decryption:9090
# 限制导入文档大小 5M
Config.Docflow.ImportExportLimit=5242880
# config to docflow editor in websocket
Config.Docflow.DefaultHost=172.16.2.95
Config.Docflow.Sharestorage=sharestorage:6700
STG_MountType=1
#STG_MountPath=
#HostMachineIp=172.16.2.7
GrpcMaxReceiveMessageSize=100
#DEVCLOUDENABLE=true
#DatabaseInitializerSqlLog=true
STG_MountType=0
UpdateKMVersion=6.1.0.0
InWiseIndexQueueName=index_inwise_queue

```

### 2. 导入所有的离线镜像

访问下载包地址,如：

```
http://download.edoc2.com:5999/km/v6.1.0.0
```

然后下载所有的 `*.tar.xz` 包，然后逐个操作，以 `wf.tar.xz` 为例，依次执行命令：

```
tar -xf wf.tar.xz # 解压出的文件为 wf.tar
docker load -i wf.tar # 把镜像包导入 docker
```

### 3. 创建基础文件夹

集群环境下，为每个服务器上都创建文件夹

```bash
mkdir -p /home/edoc2/macrowing/edoc2v5/data
cd /home/edoc2/macrowing/edoc2v5/data
mkdir -p dbbackup  edoc2  edoc2Docs  es  mongodb postgresql  rabbitmq  redis mysql sqlserver oracle dm inwise
```

### 4. docker swarm 方式部署

```bash
docker stack deploy --compose-file 'middleware-master-standalone.yml'        'midd'
docker stack deploy --compose-file 'docker-compose-deploy-searchengine.yml'  'search'
docker stack deploy --compose-file 'docker-compose-deploy-edoc2.yml'         'edoc2'
docker stack deploy --compose-file 'docker-compose-deploy-inbiz.yml'         'inbiz'
docker stack deploy --compose-file 'docker-compose-deploy-wf.yml'            'wf'
docker stack deploy --compose-file 'docker-compose-deploy-km.yml'            'km'
docker stack deploy --compose-file 'docker-compose-deploy-docflow.yml'       'docflow'
docker stack deploy --compose-file 'docker-compose-deploy-inwise.yml'        'inwise'
```

### 3. 等待程序初始化

环境起来后，导入 lic 以后，km会自动初始化和导入站点包，由于 inbiz 导入站点包时间比较长，需要等待**五分钟**左右才可使用。

## 3. 其他

### 1. 如果节点数量为 0/0 的解决办法

这种情况下就是标签缺失或者漏了，通过如下脚本解决

```bash
docker node ls -q > docker-swarm-nodes
cat docker-swarm-nodes | while read line
do
    docker node update --label-rm nodelabels --label-rm nodetype  $line
    docker node update --label-add nodelabels=Middleware --label-add nodetype=InDrive  $line
    docker node inspect $line --pretty |grep Labels: -A 6
done
\rm -f ./docker-swarm-nodes
```

### 2. 移除 swarm 集群

```bash
docker stack rm  'midd'
docker stack rm  'search'
docker stack rm  'edoc2'
docker stack rm  'inbiz'
docker stack rm  'wf'
docker stack rm  'km'
docker stack rm  'docflow'
docker stack rm  'inwise'
```

